VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 1  'Persistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDBRecord"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private adorst              As ADODB.Recordset
Private objDBAccessParent   As clsDBaccess
Private strWkFileName       As String



Private Sub Class_Initialize()
    
    strWkFileName = ""
    
End Sub

Public Property Set ParentConnectClass(obj_dbaccess As clsDBaccess)
    Set objDBAccessParent = obj_dbaccess
End Property

Public Property Get ParentConnectClass() As clsDBaccess
    ParentConnectClass = objDBAccessParent
End Property

Public Sub GetRecordSet(str_TblName As String)
    
    Call GetRecordSet_free("select * from " & str_TblName, , str_TblName)
    
End Sub


Public Sub GetRecordSet_free(ssql As String, Optional ByVal bln_ConnectSW As Boolean = False, _
                                             Optional ByVal str_tempName As String = "aa")
    Dim int_cnt     As Integer
    Dim str_buf     As String

    Set adorst = Nothing
    If adorst Is Nothing Then
        Set adorst = New ADODB.Recordset
    End If
    
    ' [Npt@C̖Oݒ
    If str_tempName <> "" Then
        str_buf = str_tempName
    Else
        str_buf = ssql
    End If
    
    With adorst
        Call .Open(ssql, objDBAccessParent.ConnectClass _
                , adOpenKeyset, adLockBatchOptimistic)
        
    End With
    
    Set adorst.ActiveConnection = Nothing
    adorst.CacheSize = 1

End Sub

Public Property Let Column(sfield As String, vntdata As Variant)
    adorst.Fields(sfield).Value = vntdata
End Property
Public Property Get Column(sfield As String) As Variant
    Column = adorst.Fields(sfield).Value
End Property

Public Property Let Column_Num(iColmnNum As Integer, vntdata As Variant)
    adorst.Fields(iColmnNum).Value = vntdata
End Property
Public Property Get Column_Num(iColmnNum As Integer) As Variant
    Column_Num = adorst.Fields(iColmnNum).Value
End Property

Public Sub CloseRecordSet()
    adorst.Close
End Sub


Public Function BatchUpdate() As Boolean
    
'    'caɍăRlNgāAob`Abvf[g
'    'ɍXVłΕۑBłȂ΃[obN
    Dim strErrMsg       As String
    

    Set adorst.ActiveConnection = objDBAccessParent.ConnectClass
    
    adorst.Filter = adFilterPendingRecords


On Error Resume Next
    'objDBAccessParent.ConnectClass.BeginTrans
    If adorst.RecordCount = 0 Then
        adorst.UpdateBatch adAffectAllChapters
    
    Else
        adorst.UpdateBatch adAffectGroup
        
    End If

    If Err.Number <> 0 Then
        MsgBox Err.Description, vbOKOnly
    End If

On Error GoTo 0

    If objDBAccessParent.ConnectClass.Errors.Count <> 0 Then
        
        Stop
                
        BatchUpdate = False
        
        adorst.MoveFirst
        Do While adorst.BOF = False And adorst.EOF = False
            If adorst.Status <> adRecOK And adorst.Status <> adRecUnmodified Then
            
                ' i荞߂L[\
                
                Dim rdofield        As Field
                Dim strErrMsgBuf    As String
                
                strErrMsg = ""
                
                For Each rdofield In adorst.Fields
                
                    If (adorst.Status And adRecDBDeleted) = adRecDBDeleted Then
                        strErrMsgBuf = "Deleted"
                    Else
                        If VarType(rdofield.Value) = vbNull Then
                            strErrMsgBuf = "null"
                        Else
                            strErrMsgBuf = rdofield.Value
                        End If
                    End If
                    strErrMsg = strErrMsg & rdofield.Name & ":" & strErrMsgBuf & "   "
                
                Next rdofield
                
            
                ' G[󋵕\
                Dim strErrTyp       As String
                Dim lngErrTyp       As Long
                Dim intErr          As Integer
                For intErr = 0 To 16
                    Select Case intErr
                    Case 0
                        strErrTyp = "adRecCanceled"
                        lngErrTyp = adRecCanceled
                    Case 1
                        strErrTyp = "adRecCantRelease"
                        lngErrTyp = adRecCantRelease
                    Case 2
                        strErrTyp = "adRecConcurrencyViolation"
                        lngErrTyp = adRecConcurrencyViolation
                    Case 3
                        strErrTyp = "adRecDBDeleted"
                        lngErrTyp = adRecDBDeleted
                    Case 4
                        strErrTyp = "adRecIntegrityViolation"
                        lngErrTyp = adRecIntegrityViolation
                    Case 5
                        strErrTyp = "adRecConcurrencyViolation"
                        lngErrTyp = adRecConcurrencyViolation
                    Case 6
                        strErrTyp = "adRecInvalid"
                        lngErrTyp = adRecInvalid
                    Case 7
                        strErrTyp = "adRecMaxChangesExceeded"
                        lngErrTyp = adRecMaxChangesExceeded
                    Case 8
                        strErrTyp = "adRecModified"
                        lngErrTyp = adRecModified
                    Case 9
                        strErrTyp = "adRecMultipleChanges"
                        lngErrTyp = adRecMultipleChanges
                    Case 10
                        strErrTyp = "adRecNew"
                        lngErrTyp = adRecNew
                    Case 11
                        strErrTyp = "adRecObjectOpen"
                        lngErrTyp = adRecObjectOpen
                    Case 12
                        strErrTyp = "adRecOutOfMemory"
                        lngErrTyp = adRecOutOfMemory
                    Case 13
                        strErrTyp = "adRecOutOfMemory"
                        lngErrTyp = adRecOutOfMemory
                    Case 14
                        strErrTyp = "adRecPendingChanges"
                        lngErrTyp = adRecPendingChanges
                    Case 15
                        strErrTyp = "adRecPermissionDenied"
                        lngErrTyp = adRecPermissionDenied
                    Case 16
                        strErrTyp = "adRecSchemaViolation"
                        lngErrTyp = adRecSchemaViolation
                    'Case 17
                    '    strErrTyp = "adRecUnmodified"
                    '    lngErrTyp = adRecUnmodified
                    End Select
                    If (adorst.Status And lngErrTyp) = lngErrTyp Then
                        strErrMsg = strErrMsg & vbCrLf & vbTab & ":" & strErrTyp
                    End If
                    
                Next intErr
                
                strErrMsg = strErrMsg & vbCrLf
                
                Debug.Print strErrMsg
                
                
            End If
            adorst.MoveNext
        Loop
        
        Stop
        
        objDBAccessParent.ConnectClass.RollBackTrans
    Else
        BatchUpdate = True
        'objDBAccessParent.ConnectClass.CommitTrans
    End If
    
    adorst.Filter = adFilterNone
    
    Set adorst.ActiveConnection = Nothing
    
    
End Function

Public Sub RollBackTrans()
    objDBAccessParent.ConnectClass.RollBackTrans
End Sub

Public Sub ComittTrans()
    objDBAccessParent.ConnectClass.CommitTrans
End Sub

Public Sub BeginTrans()
    objDBAccessParent.ConnectClass.BeginTrans
End Sub

Public Sub MoveFirst()
    adorst.MoveFirst
End Sub

Public Sub MoveLast()
    adorst.MoveLast
End Sub
Public Sub MoveNext()
    adorst.MoveNext
End Sub
Public Sub MovePrevious()
    adorst.MovePrevious
End Sub

Public Property Get EOF() As Boolean
    EOF = adorst.EOF
End Property

Public Property Get BOF() As Boolean
    BOF = adorst.BOF
End Property

Public Property Get RowCount() As Integer
    RowCount = adorst.RecordCount
End Property

Public Property Get ColCount() As Integer
    ColCount = adorst.Fields.Count
End Property


Public Sub Edit()
    'rdoRst.Edit
End Sub

Public Sub AddNew()
    adorst.AddNew
End Sub

Public Sub UpDate()
    adorst.UpDate
End Sub

Public Sub Delete()
    adorst.Delete
End Sub

Public Property Let BookMark(vntBookMark As Variant)
    adorst.BookMark = vntBookMark
End Property
Public Property Get BookMark() As Variant
    BookMark = adorst.BookMark
End Property

Public Property Get Status() As Variant
    Status = adorst.Status
End Property

Public Function IsOpen() As Boolean
    IsOpen = False
    If (adorst.State And adStateOpen) = adStateOpen Then
        IsOpen = True
    End If
End Function



Private Sub Class_Terminate()
    Set adorst = Nothing
    Set objDBAccessParent = Nothing
End Sub
