Attribute VB_Name = "modKakei"
Option Explicit

Public sInitFilePath As String
Public sAppPath      As String
Public sDBPath       As String
Public sIconPath     As String
Public Const strINI_SEC_APPINI      As String = "AppIni"


Public objDBAccess   As clsDBaccess
Private Const cnsColumnNum = 2
Private Const cnsTableNum = 2

Public Enum enmDataType
    einteger = 0
    etext = 1
    esmallint = 2
End Enum

Public Type TyRecordDataType
    sTableJPName        As String
    sTablename          As String
    sJPName               As String
    sNotNull            As Boolean
    sFieldName          As String
    eDataType           As enmDataType
    ipointx             As Integer
    sFrTableName        As String
    sFrTableField       As String
    sFrTableKey         As String
    eFrColDataType      As enmDataType
    iFrColNumber        As Integer
    Visible             As Boolean
    CellHeight          As Long
    blInputPlus         As Boolean
    blMainKey           As Boolean
    blNullPermmit       As Boolean
    blUnique            As Boolean
    iChkInputTxtLen     As Integer
End Type

'IuWFNg
Public clsPublic As clsPublic


Sub main()

    
    
    frmTitle.Show
    
    Call InitApp
    
    Call SetSectionName
    
    'Call WaitS(3)
    
    Unload frmTitle
    Set frmTitle = Nothing
    
    frmSelect.Show

End Sub
Private Sub InitApp()
        
    
    
    sAppPath = App.Path
    sInitFilePath = sAppPath & "\db\Kakebo.ini"
    sDBPath = sAppPath & "\db\Kakebo.mdb"
    
    sIconPath = sAppPath & "\Icons\"
    
    Set objDBAccess = New clsDBaccess
    Call objDBAccess.Connect(sDBPath)
    
    Set clsPublic = New clsPublic

    sNull = Chr$(0)
End Sub



Private Sub WaitS(sec As Single)
    
    Dim endt As Single
    
    endt = Timer + sec
    Do While endt >= Timer
        DoEvents
    Loop
End Sub

Public Sub AppEnd()
    
    objDBAccess.Disconnect
    Set objDBAccess = Nothing
    
    Set clsPublic = Nothing
    
    End
End Sub


Public Function GetTableJPName(ByVal sSectionName As String) As String
    Dim lngRet As Long
    Dim sBuf As String * 255
    Dim i As Integer
    lngRet = GetPrivateProfileString(sSectionName, "TableJPName", "0", sBuf, 255, sInitFilePath)
    If Left$(sBuf, 1) = "0" Then
        MsgBox "e[u{ꖼ̂ȂI"
        GetTableJPName = "e[u"
        Exit Function
    End If
    
    i = InStr(1, sBuf, sNull)
    GetTableJPName = Left$(sBuf, i - 1)
    
End Function

Private Sub SetSectionName()
    
    Dim lngRet As Long
    Dim sTableBuf As String * 255
    Dim i As Integer
    Dim j As Integer
    Dim count As Integer
    Dim sTablename As String
    
    lngRet = GetPrivateProfileString(vbNullString, "TableJPName", "0", sTableBuf, 255, sInitFilePath)
    
    count = 1
    'i = InStr(1, sTableBuf, sNull)
    i = 1
    Do While (Mid$(sTableBuf, i, 1) <> sNull) And (Mid$(sTableBuf, i + 1, 1) <> sNull)
        
        
        j = InStr(i + 1, sTableBuf, sNull)
        sTablename = Mid$(sTableBuf, i, j - i)
        
        '  AppIni ZNV̂݃pX
        If sTablename <> strINI_SEC_APPINI Then
            clsPublic.TableNumber = count
            
            
            
            clsPublic.TableSection(count) = sTablename
            count = count + 1
        End If
        
        i = j + 1
        
    Loop
    If count = 0 Then
        MsgBox "e[u͂ЂƂ"
        
        clsPublic.TableNumber = 1
        
    End If
    

End Sub

Public Function ColsNum(sTablename As String) As Integer
    Dim count As Integer
    Dim iEndFlg As Integer
    Dim sKeyName As String
    Dim lngRet   As Long
    Dim sNumber As String
    Dim sDumrecieve As String * 30
    
    iEndFlg = -1
    
    count = 1
    Do While iEndFlg = -1
    
        sNumber = CStr(count)
        If Len(sNumber) = 1 Then
            sNumber = "0" & sNumber
        End If
        sKeyName = "COL( " & sNumber & " )FieldName"
        
        lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                sDumrecieve, 30, sInitFilePath)
        If Mid$(sDumrecieve, 1, 1) = "0" Then
            iEndFlg = 0
        Else
            count = count + 1
        End If
        
    Loop
    
    ColsNum = count - 1
    
End Function
Public Function GetRecord(ByRef records As TyRecordDataType, ByVal Colnum As Integer, ByVal sTablename As String) As Integer
    
    Dim sKeyName As String
    Dim lngRet As Long
    Dim iEndFlg As Integer
    Dim sNumber As String
    Dim srecieve As String * 30
    Dim iNullPoint As Integer
    
    sNumber = CStr(Colnum)
    If Len(sNumber) = 1 Then
           sNumber = "0" & sNumber
    End If
    
    sKeyName = "COL( " & sNumber & " )FieldName"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    
    If Left$(srecieve, 1) = "0" Then
       GetRecord = -1
       Exit Function
    End If
    
    iNullPoint = InStr(srecieve, sNull)
    records.sFieldName = Left$(srecieve, iNullPoint - 1)
    
    
    sKeyName = "COL( " & sNumber & " )JPName"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    records.sJPName = Left$(srecieve, iNullPoint - 1)
    
    
    sKeyName = "COL( " & sNumber & " )ipointx"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    records.ipointx = CInt(Left$(srecieve, iNullPoint - 1))
    
    
    sKeyName = "COL( " & sNumber & " )GaibuTableName"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    records.sFrTableName = Left$(srecieve, iNullPoint - 1)
    
    
    sKeyName = "COL( " & sNumber & " )GaibuTableColName"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    records.sFrTableField = Left$(srecieve, iNullPoint - 1)
    
    
    sKeyName = "COL( " & sNumber & " )GaibuTableColKey"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    records.sFrTableKey = Left$(srecieve, iNullPoint - 1)
    
    
    sKeyName = "COL( " & sNumber & " )GaibuTableColeDataType"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    If Left$(srecieve, iNullPoint - 1) = "eText" Then
        records.eFrColDataType = etext
    ElseIf Left$(srecieve, iNullPoint - 1) = "eSmallint" Then
        records.eFrColDataType = esmallint
    ElseIf Left$(srecieve, iNullPoint - 1) = "eInteger" Then
        records.eFrColDataType = einteger
    End If
    
    
    sKeyName = "COL( " & sNumber & " )Visible"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    If Left$(srecieve, iNullPoint - 1) = "1" Then
        records.Visible = True
    Else
        records.Visible = False
    End If

    sKeyName = "COL( " & sNumber & " )CellHeight"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    records.CellHeight = CLng(Left$(srecieve, iNullPoint - 1))
    
    
    sKeyName = "COL( " & sNumber & " )eDataType"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    If Left$(srecieve, iNullPoint - 1) = "eText" Then
        records.eDataType = etext
    ElseIf Left$(srecieve, iNullPoint - 1) = "eSmallint" Then
        records.eDataType = esmallint
    ElseIf Left$(srecieve, iNullPoint - 1) = "eInteger" Then
        records.eDataType = einteger
    End If
    
    
    sKeyName = "COL( " & sNumber & " )InputPlus"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    If Left$(srecieve, iNullPoint - 1) = "1" Then
        records.blInputPlus = True
    Else
        records.blInputPlus = False
    End If
    
    sKeyName = "COL( " & sNumber & " )MainKey"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    If Left$(srecieve, iNullPoint - 1) = "1" Then
        records.blMainKey = True
    Else
        records.blMainKey = False
    End If
    
    sKeyName = "COL( " & sNumber & " )NullPermmit"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    If Left$(srecieve, iNullPoint - 1) = "1" Then
        records.blNullPermmit = True
    Else
        records.blNullPermmit = False
    End If
    
    sKeyName = "COL( " & sNumber & " )Unique"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    If Left$(srecieve, iNullPoint - 1) = "1" Then
        records.blUnique = True
    Else
        records.blUnique = False
    End If
    
    sKeyName = "COL( " & sNumber & " )CheckInputTextLength"
    lngRet = GetPrivateProfileString(sTablename, sKeyName, "0", _
                srecieve, 30, sInitFilePath)
    iNullPoint = InStr(srecieve, sNull)
    records.iChkInputTxtLen = CLng(Left$(srecieve, iNullPoint - 1))



    GetRecord = 0
    
End Function

'Private Function GetProFile_ColumnProperty(ByVal sKeyName, DataType As enmDataType) As Variant
'
'    Dim sKeyName As String
'    Dim lngret As Long
'    Dim iEndFlg As Integer
'    Dim sNumber As String
'    Dim srecieve As String * 30
'    Dim iNullPoint As Integer
'
'
'
'    lngret = GetPrivateProfileString(sTablename, sKeyName, "0", _
'                srecieve, 30, sInitFilePath)
'    iNullPoint = InStr(srecieve, sNull)
'    If Left$(srecieve, 1) = "0" Then
'        GetProFile_ColumnProperty = CByte(&HFF)
'        Exit Function
'    End If
'    Select Case DataType
'
'
'
'End Function


Public Function GetSubSql(ByRef tpCols As TyRecordDataType, ByVal vntValue As Variant) As String

    Dim sRet As String
   
    
    Select Case TypeName(vntValue)
    Case "Integer", "Long"
        sRet = CStr(vntValue)
    Case "String"
        sRet = """" & CStr(vntValue) & """"
    End Select
    
    GetSubSql = "Select " & tpCols.sFrTableField & " From " & _
        tpCols.sFrTableName & " Where " & tpCols.sFrTableKey & " = " & _
            sRet
    
    
End Function

Public Function GetVntToEDataType(ByVal vntValue As Variant, ByVal enmDataType As enmDataType) As Variant
    
    Select Case enmDataType
    Case einteger
        If vntValue <> "" Then
            GetVntToEDataType = CLng(vntValue)
        Else
            GetVntToEDataType = Null
        End If
        
    Case esmallint
        If vntValue <> "" Then
            GetVntToEDataType = CInt(vntValue)
        Else
            GetVntToEDataType = 0
        End If
        
    Case etext
        GetVntToEDataType = Trim(CStr(vntValue))
    End Select

End Function

Public Function vntComp(ByVal vntValue1 As Variant, ByVal vntValue2 As Variant, enmDType As enmDataType) As Integer
    
    If enmDType = etext Then
        ' 06.01.16 var1="a@", var2="H"ŔrltɂȂ DB,FlexGrid 
        ' ȂoOC
        'vntComp = StrComp(vntValue1, vntValue2)
        vntComp = StrComp(vntValue1, vntValue2, vbTextCompare)
        
    ElseIf enmDType = einteger Or enmDType = esmallint Then
        
        If vntValue1 < vntValue2 Then
            vntComp = -1
        ElseIf vntValue1 > vntValue2 Then
            vntComp = 1
        Else
            vntComp = 0
        End If
    End If


End Function



' ini t@Ce[u N ̃JƂ̊Oe[u擾
' 0 :OK else:NG
Public Function GetTableDef(ByVal iTblNum As Integer, _
            typCols() As TyRecordDataType, _
            typFrCols() As TyRecordDataType) As Integer
    
    Dim iret As Integer
    Dim iNum As Integer
    Dim iFrNum As Integer
    Dim count As Integer
    Dim iFrNowNum As Integer
    
    'IniFileJ̐
    iNum = ColsNum(clsPublic.TableSection(iTblNum))
    'JŔzĒ`
    ReDim typCols(1 To iNum)
    'tB[h̎擾
    For count = 1 To iNum
        iret = GetRecord(typCols(count), count, clsPublic.TableSection(iTblNum))
        If iret <> 0 Then
            MsgBox "JINIt@C̎擾sII"
            Erase typCols
            Erase typFrCols
            GetTableDef = 1
            Exit Function
        End If
    Next
    
    'OL[pJtB[h`
    iFrNum = 0
    For count = 1 To iNum
       If typCols(count).sFrTableName <> "Nothing" Then
           iFrNum = iFrNum + 1
       End If
    Next
    If iFrNum <> 0 Then
        ReDim typFrCols(1 To iFrNum)
        iFrNowNum = 0
        For count = 1 To iNum
           If typCols(count).sFrTableName <> "Nothing" Then
                iFrNowNum = iFrNowNum + 1
                typFrCols(iFrNowNum).ipointx = typCols(count).ipointx
                
                If typCols(count).blInputPlus = True Then
                    typCols(count).blInputPlus = False
                    typFrCols(iFrNowNum).blInputPlus = True
                End If
                
                typCols(count).ipointx = iNum - 1 + iFrNowNum
                typFrCols(iFrNowNum).iFrColNumber = count
                typCols(count).iFrColNumber = iFrNowNum
                typFrCols(iFrNowNum).eFrColDataType = typCols(count).eFrColDataType
                
                iFrNum = iFrNum + 1
           End If
        Next
    Else
        ReDim typFrCols(0)
    End If

    GetTableDef = 0

End Function


Public Function IsHaveFrKey(typCol As TyRecordDataType) As Boolean
    
    If typCol.sFrTableName <> "Nothing" Then
        IsHaveFrKey = True
    Else
        IsHaveFrKey = False
    End If
End Function
